<template>
  <div class="app-container">
    <!-- 查询和其他操作 -->
    <div class="filter-container" style="margin: 10px 0 10px 0;">
      <el-form :inline="true" label-width="68px" style="margin-bottom: 8px;">
        <el-col :span="18">
        <el-form-item label="项目">
          <el-select
            v-model="queryParams.source"
            class="filter-item"
            placeholder="项目"
            style="width: 140px"
            filterable
            clearable
            remote
            reserve-keyword
          >
            <el-option
              v-for="item in sourceData"
              :key="item.source"
              :label="item.name"
              :value="item.source"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-button class="filter-item" type="primary" icon="el-icon-search" @click="handleFind">查找</el-button>
        </el-col>
        <el-col :span="6">
          <el-button class="filter-item" type="primary" @click="handleAdd" icon="el-icon-edit">新增项目</el-button>
        </el-col>
      </el-form>
    </div>

    <el-table :data="tableData" style="width:100%" class="show_table" >
      <el-table-column label="编号" width="60" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.uid }}</span>
        </template>
      </el-table-column>
      <el-table-column label="项目名稱" width="100" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.name }}</span>
        </template>
      </el-table-column>

      <el-table-column label="普通用戶是否限制" width="80" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span v-if="scope.row.ordmemberLimit== 1">限制</span>
          <span v-if="scope.row.ordmemberLimit == 0">不限制</span>
        </template>
      </el-table-column>
      <el-table-column label="会员升级提示图" width="160" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <img  v-viewer v-if="scope.row.photo" :src="scope.row.photo" style="width: 130px;height: 70px;"/>
        </template>
      </el-table-column>
      <el-table-column label="会员升级提示文字" width="250" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.upgradeMemo }}</span>
        </template>
      </el-table-column>
      <el-table-column label="币别名称" width="100" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.currency }}</span>
        </template>
      </el-table-column>
      <el-table-column label="会员升级跳转URL" width="200" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.upgradeUrl }}</span>
        </template>
      </el-table-column>
      <el-table-column label="创建时间" width="180" align="center" prop="createTime" sortable="custom" :sort-by="['createTime']">
        <template slot-scope="scope">
          <span>{{ scope.row.createTime }}</span>
        </template>
      </el-table-column>
      <el-table-column label="操作" min-width="180" fixed="right" align="center">
        <template slot-scope="scope">
          <el-button @click="handleEdit(scope.row)"  type="primary" size="small">编辑</el-button>
          <router-link :to="{path: '/books/booksUserCost', query: {projectUid:scope.row.uid,projectName:scope.row.name}}">
            <el-button type="danger" size="small">用戶费用设定</el-button>
          </router-link>
          <router-link :to="{path: '/books/booksUserLevel', query: {source:scope.row.source,projectName:scope.row.name}}">
            <el-button type="danger" size="small">用戶等级设定</el-button>
          </router-link>
        </template>
      </el-table-column>
    </el-table>

    <!--分页-->
    <div class="block">
      <el-pagination
        @size-change="handleSizeChange"
        @current-change="handleCurrentChange"
        :current-page.sync="currentPage"
        :page-sizes="[40, 80, 120, 200]"
        :page-size="pageSize"
        layout="total, prev, pager, next, jumper, sizes"
        :total="total"
      ></el-pagination>
    </div>
    <!-- 添加或修改对话框 -->
    <el-dialog :title="title" :visible.sync="dialogFormVisible" width="30%" :before-close="projectHandleClose" center>
      <el-form :model="form" :rules="rules" ref="form" label-width="auto">
        <el-form-item label="分类ID" :label-width="formLabelWidth" v-if="form.uid">
          <span>{{form.uid}}</span>
        </el-form-item>
        <el-form-item label="项目名称" :label-width="formLabelWidth" prop="name">
          <el-input v-model="form.name" style="width:80%"></el-input>
        </el-form-item>
        <el-form-item label="来源" :label-width="formLabelWidth" prop="source">
          <el-input v-model="form.source" oninput ="value=value.replace(/[^\d]/g,'')"  style="width:80%"></el-input>
        </el-form-item>
        <el-form-item label="普通用户是否限制" :label-width="formLabelWidth" prop="ordmemberLimit">
           <input type="radio" v-model="form.ordmemberLimit" value="1" />&nbsp; 限制&nbsp;
           <input type="radio" v-model="form.ordmemberLimit" value="0" />&nbsp; 不限制 &nbsp;
        </el-form-item>
        <el-form-item label="会员升级提示图" :label-width="formLabelWidth">
          <div class="imgBody" v-if="form.photo">
            <i class="el-icon-error inputClass" v-show="icon" @click="deletePhoto()" @mouseover="icon = true"></i>
            <img @mouseover="icon = true" @mouseout="icon = false" v-bind:src="form.photo" style="display:inline; width: 195px;height: 105px;"/>
          </div>
          <div v-else class="uploadImgBody" @click="checkPhoto">
            <i class="el-icon-plus avatar-uploader-icon"></i>
          </div>
        </el-form-item>
        <el-form-item label="会员升级提示文字" :label-width="formLabelWidth" prop="upgradeMemo">
          <textarea v-model="form.upgradeMemo" type="text" auto-complete="off" style="width: 80%;height: 100px"></textarea>
        </el-form-item>
        <el-form-item label="币别名称" :label-width="formLabelWidth" prop="currency">
          <el-input v-model="form.currency" style="width:80%"></el-input>
        </el-form-item>
        <el-form-item label="会员升级跳转URL" :label-width="formLabelWidth" prop="upgradeUrl">
          <el-input v-model="form.upgradeUrl" style="width:80%"></el-input>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button @click="projectHandleClose">取 消</el-button>
        <el-button type="primary" @click="submitForm">确 定</el-button>
      </div>
    </el-dialog>
    <!--图集图片信息-->
    <el-drawer :visible.sync="pictureFormVisible"  :direction="direction" :size="size" :before-close="pictureHandleClose">
      <el-form  :model="picForm" :span="50" ref="picForm">

        <el-tabs class="scroll"
                 v-model="activeName"
                 type="border-card"
                 tab-position="left"
        >
          <el-row >
            <el-col
              v-for="(picture, index) in pictureData"
              :key="picture.uid"
              style="padding: 6px"
              :xs="24"
              :sm="12"
              :md="12"
              :lg="6"
              :xl="4"
            >
              <el-card
                :body-style="{ padding: '0px', textAlign: 'center' }"
                shadow="always"
              >
                <el-image class="showimg"
                          :src="picture.pictureUrl"
                          style="cursor:pointer"
                          fit="cover"
                          @click="showPicture(picture.pictureUrl)"
                          v-if="picture.uid"
                />

                <div @click="showPicture(picture.pictureUrl)">
                  <span class="media-title" v-if="picture.updateTime">{{picture.updateTime}}</span>
                  <span class="media-title" v-else>图片 {{index + 1}}</span>
                </div>
              </el-card>

            </el-col>
          </el-row>

        </el-tabs>


      </el-form>
      <div slot="footer" class="dialog-footer">
      </div>
    </el-drawer>

    <el-dialog :visible.sync="dialogPictureVisible" fullscreen style="text-align: center">
      <img :src="dialogImageUrl" alt="">
    </el-dialog>


    <avatar-cropper
      v-show="imagecropperShow"
      :key="imagecropperKey"
      :width="224"
      :height="148"
      :url="url"
      lang-type="zh"
      @close="close"
      @crop-upload-success="cropSuccess"
    />
  </div>
</template>

<script>
import {
  getBooksProjectList,
  addBooksProject,
  editBooksProject,
  getSourceList,
} from "@/api/booksProject";
import AvatarCropper from '@/components/AvatarCropper'
export default {
  components: {
    AvatarCropper
  },
  created() {
    this.booksProjectList();
    this.sourceList();
  },
  data() {
    return {
      picForm:{
        uid: null
      },
      direction: 'ltr',
      size: '100%',
      // 图片上传路径
      url: process.env.PICTURE_API + "/file/cropperPicture",
      dialogImageUrl: "", //图片显示地址
      queryParams:{//查询参数
        source: "", //项目
      },
      form: {
        uid: null,
        name: null,
        fileUid: null,
        upgradeMemo: null,
        upgradeUrl: null,
        ordmemberLimit: null,
        currency:null,
        source:null,
      },
      tableData: [],
      sourceData: [
        {
          name:'全部',
          source:''}
      ],
      currentPage: 1,
      pageSize: 40,
      total: 0, //总数量

      dialogFormVisible: false,
      pictureFormVisible: false,
      dialogPictureVisible: false,//当前分类图集列表
      isEditForm: false,
      isAddForm: false,
      photo:"",
      imagecropperKey: 0,
      imagecropperShow: false, //控制图片选择器的显示
      fileIds: "",
      icon: false, //控制删除图标的显示
      isFirstPhotoVisible: true, // 图片选择器是否首次显示【用于懒加载】
      rules: {
        upgradeMemo: [
          {min: 0, max: 300, message: '最多输入300个字'},
        ],
        upgradeUrl: [
          {min: 0, max: 200, message: '最多输入200个字'},
        ],
        source: [
          {required: true, message: '来源不能为空', trigger: 'blur'},
        ],
        name: [
          {required: true, message: '项目名称不能为空', trigger: 'blur'},
          {min: 1, max: 32, message: '长度在1到32个字符'},
        ]
      },
    };
  },
  methods: {
    booksProjectList: function() {
      this.queryParams.currentPage = this.currentPage;
      this.queryParams.pageSize = this.pageSize;
      this.queryParams.orderByDescColumn = this.orderByDescColumn
      this.queryParams.orderByAscColumn = this.orderByAscColumn
      getBooksProjectList(this.queryParams).then(response => {
        this.tableData = response.data.records;
        this.currentPage = response.data.current;
        this.pageSize = response.data.size;
        this.total = response.data.total;
      });
    },
    sourceList: function() {
      var sourceParams = {};
      sourceParams.pageSize = 1000;
      sourceParams.currentPage = 1;
      getSourceList(sourceParams).then(response => {
        this.sourceData.push(...response.data.records);
      });
    },
    handleFind: function() {
      this.currentPage = 1
      this.booksProjectList();
    },
    getFormObject: function() {
      var formObject = {
        uid: null,
        name: null,
        fileUid: null,
        ordmemberLimit:1,
        upgradeMemo: null,
        upgradeUrl: null,
        currency:null,
        source:null,
      };
      return formObject;
    },
    deletePhoto: function() {
      this.form.photo = null;
      this.form.ava = "";
      this.icon = false;
    },
    checkPhoto() {
      this.photo = null;
      this.fileUid = "";
      this.imagecropperShow = true;
      this.isFirstPhotoVisible = false
    },
    showPicture: function(url) {
      this.dialogPictureVisible = true
      this.dialogImageUrl = url
    },
    handleAdd: function() {
      this.title = "增加项目"
      this.dialogFormVisible = true;
      this.form = this.getFormObject();
      this.isEditForm = false;
      this.isAddForm = true;
    },
    handleEdit: function(row) {
      this.title = "编辑项目";
      this.dialogFormVisible = true;
      this.isEditForm = true;
      this.isAddForm = false;
      this.form = row;
    },
    handleUserCost: function(row) {
      this.title = "编辑项目";
      this.dialogFormVisible = true;
      this.isEditForm = true;
      this.isAddForm = false;
      this.form = row;
    },
    submitForm: function() {
      this.$refs.form.validate((valid) => {
        if(!valid) {
          console.log("校验出错")
        } else {
          if (this.isEditForm) {
            editBooksProject(this.form).then(response => {
              this.$commonUtil.message.success(response.message)
              this.dialogFormVisible = false;
              this.booksProjectList();
            });
          } else {
            addBooksProject(this.form).then(response => {
              if (response.code == this.$ECode.SUCCESS) {
                this.$commonUtil.message.success(response.message)
              } else {
                this.$commonUtil.message.error(response.message)
              }
              this.dialogFormVisible = false;
              this.booksProjectList();
            });
          }
        }
      })
    },

    /**
     * 翻页事件
     */
    handleSizeChange(val) {
      this.pageSize = val;
      this.booksProjectList();
    },
    handleCurrentChange: function(val) {
      this.currentPage = val;
      this.booksProjectList();
    },
    pictureHandleClose(){
      this.pictureData = [];
      this.pictureFormVisible = false;
    },

    projectHandleClose(){
      this.dialogFormVisible = false;
      this.$refs.form.clearValidate();
      this.booksProjectList();
    },

    cropSuccess(resData) {
      this.imagecropperShow = false
      this.imagecropperKey = this.imagecropperKey + 1
      let photo = resData[0].url
      this.form.photo = photo;
      this.form.fileUid = resData[0].uid
    },
    close() {
      this.imagecropperShow = false
    },

  }
};
</script>
<style scoped>
  .el-form-item {
    margin-bottom: 10px;
  }
</style>
